#include "include/map2d.h"
#include "ui_map2d.h"
#include "globe/ot_proj.h"
#include "include/mainwindow.h"
#include "QTime"
#include <QDesktopWidget>
Map2d::Map2d(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Map2d)
{
    ui->setupUi(this);
   //QRect screen = QApplication::desktop()->screenGeometry();
    // this->move( screen.center() - this->rect().center() );
    //m_map = new ProjectionWindow(ui->widget);
   // m_map->loadTexture(m_workDir.toAscii().data());
   // m_map->setGeometry(0,0,ui->widget->width(),ui->widget->height());


}

Map2d::~Map2d()
{
    delete ui;
}

void Map2d::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void Map2d::setWorkDir(QString& dir)
{
    m_workDir = dir;

}

void Map2d::init2d(QString m_workDir)
{   m_map = new ProjectionWindow(ui->widget);
    m_map->loadTexture(m_workDir.toAscii().data());
  //  int i=ui->widget->width();

   // int j= ui->widget->height();
    m_map->setGeometry(0,0,ui->widget->width()+100,ui->widget->height()+100);

}

int Map2d::CalculateFPS(int m_frameCount)
{
QTime m_time;
m_time.start();
 QString str;

 QDesktopWidget *d = QApplication::desktop();
 int cur_x = d->width();     // returns desktop width
 int cur_y = d->height();    // returns desktop height
int pixelx_move= cur_x-this->width(); //количество пикселей по ширине в экране
int pixely_move=cur_y-this->height() - this->geometry().y();//количество пикселей по высоте в экране без заголовка
this->move(0,0);




for(int i=1;i<=m_frameCount;i++)
    {

      m_map->resize(ui->widget->width()+300*i/m_frameCount,ui->widget->height()+200*i/m_frameCount);
          this->move(i%pixelx_move,i%pixely_move);
      ui->widget->repaint();

      ui->label_out->setText(str.sprintf("Frames: %d",i));
    //  this->repaint();

    }
//int elpresedtime =m_time->elapsed();
//delete m_time;
return m_time.elapsed();
}
