#include "include/memtest.h"
#include "ui_memtest.h"
#include <stdlib.h>
#include <QTimer>
#include <QDateTime>
#include <stdlib.h>


//#include "ui_mainwindow.h"


Memtest::Memtest(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Memtest)
{
    ui->setupUi(this);
    QObject::connect(ui->pushButton,SIGNAL(clicked()),this,SLOT(StartTestRAM()));
   ui->progressBar_st_w->setValue(0);
   ui->progressBar_st_r->setValue(0);
   ui->progressBar_st_rw->setValue(0);


   ui->progressBar_d_w->setValue(0);
   ui->progressBar_d_r->setValue(0);
   ui->progressBar_d_rw->setValue(0);
}

Memtest::~Memtest()
{




    delete ui;
}

void Memtest::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Memtest::Set_size_count(int size, quint64 count)
 {
    ui->lineEdit_ram_size->setText(QString::number(size));
     ui->lineEdit_ram_count->setText(QString::number(count));
 }


/*void Memtest::Dinamic_RAM(quint64 count_n,int blocksize )
{
    //char *p1 =new char[blocksize];
  // p1 = (char *)malloc (blocksize);
  QByteArray ba;
  ba.resize(blocksize);
   //char *p = new char[blocksize];
   for(int i=0;i<=blocksize-1;i++)
   {
       ba[i]='0';
       //p[i]='1';
   }

    QByteArray ba1;
    ba1.resize(blocksize);

    //char *p = new char[blocksize];


  // p = (char *)malloc (blocksize*count_n);


   //if(!p) {
   //qDebug("Требуемая память не выделена.\n");
   //  exit(1);
  // }
   QTime m_time;
   ui->progressBar_1->setMaximum(100);
   m_time.start();


    for(quint64 i=1;i<=count_n;i++)
        {
 //       QByteArray ba1;
 //       ba1.resize(blocksize);
        ba1=ba;

         ui->progressBar_1->setValue((quint64) ((i)*100)/ count_n);
               };

double v;//=0.000000000000000000000001;
quint64 k = 1024*1024;
//quint64 k = 1;
quint64 kol_byte = count_n*blocksize;

int sec_time = m_time.elapsed();


v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
QString str;

str.setNum(v);
//str.sprintf("%0.3f  MByte/sec ",(kol_byte)/k)*1000.0/m_time.elapsed());
//ui->lineEdit_st1->setText(str.sprintf("%0.3f, MByte/sec",v));
ui->lineEdit_st1->setText(str.sprintf("%0.2f, MByte/sec",v));
//ui->lineEdit_st1->setText(str.setNum(v));


//delete[] p1;
//delete[] p;
//QObject::trUtf8("Тестирование оперативной памяти")


}
*/


void Memtest::Static_RAM(quint64 count_n,int blocksize ,QString rw )
{  // rw признак r -read w write rw read/write
QString str1;
str1="";

//char *charstr;

int number=9;

for(int i=0;i<=blocksize-1;i++)
   {
 //      ba[i]='0';
    int randomValue = qrand() % number;
    //char ch =  char(randomValue);
    str1.append(QString::number(randomValue));
    //   str1.append('0');


   }
  //  quint64 str1_size =sizeof(str1[1024]);

   //int str1_size1= str1.size();
   QTime m_time;

   if (rw=="w") { // -------write static
   ui->progressBar_st_w->setMaximum(100);
   m_time.start();
   QString *p =new QString;
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }

    for(quint64 i=1;i<=count_n;i++)
        {
        //p->clear();
        //p->append(&str1);
        *p=str1;
        //Change_first_char(&str1);
       // int p_size1= sizeof(p);
        ui->progressBar_st_w->setValue((quint64) ((i)*100)/ count_n);

        };

        delete p;
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    // str1_size =sizeof(&str1);
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_w->setText(str.sprintf("%0.2f, MByte/sec",v));
        }


   if (rw=="r") {     // -------read static
   ui->progressBar_st_r->setMaximum(100);
   m_time.start();

   QString *p =new QString;
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }
   //p->clear();
   //p->append(&str1);
*p=str1;
    for(quint64 i=1;i<=count_n;i++)
        {
            str1=*p;
            ui->progressBar_st_r->setValue((quint64) ((i)*100)/ count_n);
        };

     delete p;
     // result
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_r->setText(str.sprintf("%0.2f, MByte/sec",v));
        }

   if (rw=="rw") {     // -------read/write static
   ui->progressBar_st_rw->setMaximum(100);
   m_time.start();

   QString *p =new QString;
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }
   p->clear();
   p->append(&str1);

    for(quint64 i=1;i<=count_n;i++)
        {
            str1=*p;
            *p=str1;
            ui->progressBar_st_rw->setValue((quint64) ((i)*100)/ count_n);
        };
     delete p;
     // result
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_rw->setText(str.sprintf("%0.2f, MByte/sec",v));
        }

}
//   string
void Memtest::Static_RAM_string(quint64 count_n,int blocksize ,QString rw )
{  // rw признак r -read w write rw read/write
QString str1;
str1="";

//char *charstr;
char buf[count_n];
int number=9;

for(int i=0;i<=blocksize-1;i++)
   {
 //      ba[i]='0';
    int randomValue = qrand() % number;

    buf[i] =  char(randomValue);
   // str1.append(QString::number(randomValue));
    //   str1.append('0');


   }
  //  quint64 str1_size =sizeof(str1[1024]);

   //int str1_size1= str1.size();
   QTime m_time;

   if (rw=="w") { // -------write static
   ui->progressBar_st_w->setMaximum(100);
   m_time.start();
   QString *p =new QString;
   char *chstr;

   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }

    for(quint64 i=1;i<=count_n;i++)
        {
        //p->clear();
        //p->append(&str1);
        *p=str1;
        strcpy(chstr,buf);
        //Change_first_char(&str1);
        //int p_size1= sizeof(p);
        ui->progressBar_st_w->setValue((quint64) ((i)*100)/ count_n);

        };

        delete p;
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    // str1_size =sizeof(&str1);
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_w->setText(str.sprintf("%0.2f, MByte/sec",v));
        }


   if (rw=="r") {     // -------read static
   ui->progressBar_st_r->setMaximum(100);
   m_time.start();

   QString *p =new QString;
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }
   //p->clear();
   //p->append(&str1);
*p=str1;
    for(quint64 i=1;i<=count_n;i++)
        {
            str1=*p;
            ui->progressBar_st_r->setValue((quint64) ((i)*100)/ count_n);
        };

     delete p;
     // result
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_r->setText(str.sprintf("%0.2f, MByte/sec",v));
        }

   if (rw=="rw") {     // -------read/write static
   ui->progressBar_st_rw->setMaximum(100);
   m_time.start();

   QString *p =new QString;
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }
   p->clear();
   p->append(&str1);

    for(quint64 i=1;i<=count_n;i++)
        {
            str1=*p;
            *p=str1;
            ui->progressBar_st_rw->setValue((quint64) ((i)*100)/ count_n);
        };
     delete p;
     // result
    double v;
    quint64 k = 1024*1024;
    //quint64 k = 1;
    quint64 kol_byte = count_n*blocksize*2;
    int sec_time = m_time.elapsed();
    v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
    QString str;
    str.setNum(v);
    ui->lineEdit_st_rw->setText(str.sprintf("%0.2f, MByte/sec",v));
        }

}


/*
void Memtest::Static_RAM(quint64 count_n,int blocksize )
{

  // p1 = (char *)malloc (blocksize);
 // QByteArray ba;
 // ba.resize(blocksize);
   char *p1 = new char[blocksize];
   for(int i=0;i<=blocksize-1;i++)
   {
 //      ba[i]='0';
       p1[i]='0';
   }

//    QByteArray ba1;
 //   ba1.resize(blocksize);

    //char *p = new char[blocksize];


  // p = (char *)malloc (blocksize*count_n);


      // char *p =new char[blocksize];
   

   QTime m_time;
   ui->progressBar_1->setMaximum(100);

   char *p =new char[blocksize];
   if(!p) {
       qDebug("Требуемая память не выделена.\n");
       exit(1);
         }
   m_time.start();
    for(quint64 i=1;i<=count_n;i++)
        {

 //char ch;
        for(int j=0;j<=blocksize-1;j++)
        {
           p[j]='0';
        }

         ui->progressBar_1->setValue((quint64) ((i)*100)/ count_n);

        };
      delete[] p;
double v;//=0.000000000000000000000001;
quint64 k = 1024*1024;
//quint64 k = 1;
quint64 kol_byte = count_n*blocksize;

int sec_time = m_time.elapsed();


v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
QString str;

str.setNum(v);
//str.sprintf("%0.3f  MByte/sec ",(kol_byte)/k)*1000.0/m_time.elapsed());
//ui->lineEdit_st1->setText(str.sprintf("%0.3f, MByte/sec",v));
ui->lineEdit_st1->setText(str.sprintf("%0.2f, MByte/sec",v));
//ui->lineEdit_st1->setText(str.setNum(v));


//delete[] p1;
//delete[] p;
//QObject::trUtf8("Тестирование оперативной памяти")


}
*/
void Memtest::Dinamic_RAM(quint64 count_n,int blocksize, QString rw )
{
QString str1;
str1="";
int number=9;


for(int i=0;i<=blocksize-1;i++)
   {
 //      ba[i]='0';
    int randomValue = qrand() % number;
    str1.append(QString::number(randomValue));
    //   str1.append('0');
   }


if (rw=="w")   //dinamic read
    {
        QTime m_time;
        ui->progressBar_d_w->setMaximum(100);
        m_time.start();

    for(quint64 i=1;i<=count_n;i++)
        {
        QString *p =new QString;
            if(!p) {
                qDebug("Требуемая память не выделена.\n");
                exit(1);
                  }
            // p->clear();
             //p->append(&str1);
             *p=str1;

             ui->progressBar_d_w->setValue((quint64) ((i)*100)/ count_n);
             delete p;
                  };

          double v;
            quint64 k = 1024*1024;
            //quint64 k = 1;
            quint64 kol_byte = count_n*blocksize;
            int sec_time = m_time.elapsed();
            v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
            QString str;
            str.setNum(v);
            ui->lineEdit_d_w->setText(str.sprintf("%0.2f, MByte/sec",v));
      }
if (rw=="r")   // -------read dinamic
    {
        QTime m_time;
        ui->progressBar_d_r->setMaximum(100);
        m_time.start();

        QString s;

    for(quint64 i=1;i<=count_n;i++)
        {
                 QString *p =new QString;
                       if(!p) {
                         qDebug("Требуемая память не выделена.\n");
                          exit(1);
                             }
                  p=&str1;
                  s=*p;

                  ui->progressBar_d_r->setValue((quint64) ((i)*100)/ count_n);
                 p=NULL;
                  delete p;
                  };

          double v;
            quint64 k = 1024*1024;
            //quint64 k = 1;
            quint64 kol_byte = count_n*blocksize*2;  // 2 байта на символ QString
            int sec_time = m_time.elapsed();
            v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
            QString str;
            str.setNum(v);
            ui->lineEdit_d_r->setText(str.sprintf("%0.2f, MByte/sec",v));
      }
if (rw=="rw")  // -------read/write dinamic
    {
        QTime m_time;
        ui->progressBar_d_rw->setMaximum(100);
        m_time.start();

    for(quint64 i=1;i<=count_n;i++)
        {
                 QString *p =new QString;
                       if(!p) {
                         qDebug("Требуемая память не выделена.\n");
                          exit(1);
                           }
                   *p=str1;
                   str1=*p;

                  ui->progressBar_d_rw->setValue((quint64) ((i)*100)/ count_n);
                  delete p;
                  };

          double v;
            quint64 k = 1024*1024;
            //quint64 k = 1;
            quint64 kol_byte = count_n*blocksize*2;
            int sec_time = m_time.elapsed();
            v  = (double)((quint64)kol_byte/(sec_time))*1000/k;
            QString str;
            str.setNum(v);
            ui->lineEdit_d_rw->setText(str.sprintf("%0.2f, MByte/sec",v));
      }
}

    void Memtest::StartTestRAM()
    {

    int blocksize = ui->lineEdit_ram_size->text().toInt();
    quint64 count_n = (quint64) ui->lineEdit_ram_count->text().toLongLong();

 // int blocksize=1024;
 // quint64 count_n =10000000;

// this->Static_RAM(count_n,blocksize,"w");
 this->Static_RAM(count_n,blocksize,"w");
 this->Static_RAM(count_n,blocksize,"r");
 this->Static_RAM(count_n,blocksize,"rw");

  this->Dinamic_RAM(count_n,blocksize,"w");
   this->Dinamic_RAM(count_n,blocksize,"r");
   this->Dinamic_RAM(count_n,blocksize,"rw");

   signal_Set_value_RAM(
           ui->lineEdit_st_w->text(),
           ui->lineEdit_st_r->text(),
           ui->lineEdit_st_rw->text(),
           ui->lineEdit_d_w->text(),
           ui->lineEdit_d_r->text(),
           ui->lineEdit_d_rw->text()
                );
this->hide();
    }
