#include "include/myclient.h"
#include "ui_myclient.h"
#include <QtNetwork>
#include <QtGui>

MyClient::MyClient(const QString& strHost, int nPort, QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MyClient)
{
    ui->setupUi(this);
    m_pTcpSocket = new QTcpSocket(this);
Error_connect=false;
    m_pTcpSocket->connectToHost(strHost, nPort);
    connect(m_pTcpSocket, SIGNAL(connected()), SLOT(slotConnected()));
    connect(m_pTcpSocket, SIGNAL(readyRead()), SLOT(slotReadyRead()));
    connect(m_pTcpSocket, SIGNAL(error(QAbstractSocket::SocketError)),
            this,         SLOT(slotError(QAbstractSocket::SocketError))
           );
   m_nNextBlockSize=0;
    connect(ui->m_ptxtInput, SIGNAL(returnPressed()),
            this,        SLOT(slotSendToServer())
           );
    ui->m_ptxtInfo->setReadOnly(true);

   //QPushButton* pcmd = new QPushButton("&Send");
    connect(ui->pcmd, SIGNAL(clicked()), SLOT(slotSendToServer()));
    connect(ui->pushButton_startNet, SIGNAL(clicked()), SLOT(StartNetTest()));

connect(this, SIGNAL(signalSendStrToServer(QString)), SLOT(slotSendTestToServer(QString)));
Time_packet=0;
//int max_time=0;
//int cur_time=0;
    /*QList< QHostAddress > addresses = QHostInfo::fromName( QHostInfo::localHostName() ).addresses();
       foreach ( const QHostAddress & a, addresses )
       {
           QString protocol = "???";
           switch ( a.protocol() )
           {
               case QAbstractSocket::IPv4Protocol:
                   protocol = "IPv4";
               break;
               case QAbstractSocket::IPv6Protocol:
                   protocol = "IPv6";
               break;
           }
           qDebug() << a.toString() << "(" << protocol << ")";
       }
*/
    /*   QHostInfo info;
       QString IPAddress;
       QHostAddress Address;
      qDebug()<< info.addresses();
       qDebug()<<  info.localHostName();
       qDebug()<<"IPV4 is ::" + QString::number(Address.toIPv4Address());
       qDebug()<<" Broad Cast Address is ::" <<QString::number(Address.Broadcast);
       qDebug()<< "Any IP Address is" << QString::number(Address.Any);
       qDebug()<<"Local Host Address is :: " << QString::number(Address.LocalHost);
*/
}

MyClient::~MyClient()
{
    delete ui;
}

void MyClient::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}
void MyClient::set_count_blocksize(int count, int blocksize)
           {this->count_n=count;
           this->blocksize=blocksize;
                      };
/*

void MyClient::slotReadyRead()
{
    QDataStream in(m_pTcpSocket);
    in.setVersion(QDataStream::Qt_4_4);
    for (;;) {
        if (!m_nNextBlockSize) {
            if (m_pTcpSocket->bytesAvailable() < sizeof(quint16)) {
                break;
            }
            in >> m_nNextBlockSize;
        }

        if (m_pTcpSocket->bytesAvailable() < m_nNextBlockSize) {
            break;
        }
        QTime   time;
        QString str;
        in >> time >> str;

        ui->m_ptxtInfo->append(time.toString() + " " + str);
        m_nNextBlockSize = 0;
    }
}
*/
void MyClient::slotReadyRead()
{
    QDataStream in(m_pTcpSocket);
    in.setVersion(QDataStream::Qt_4_4);
    for (;;) {
        if (!m_nNextBlockSize) {
            if (m_pTcpSocket->bytesAvailable() < sizeof(quint16)) {
                break;
            }
            in >> m_nNextBlockSize;
        }

        if (m_pTcpSocket->bytesAvailable() < m_nNextBlockSize) {
            break;
        }

        QTime   time;
        QString str;
        in >> time >> str;
        if (str.left(6) ==" Start")
       {
            Time_packet=Timer_client.elapsed();  //разница между таймерами на сервере и клиенте
           max_time=Time_packet;
           cur_time=Time_packet;
            //
           //   TestToServer(this->count_n,this->blocksize);
           emit signalSendStrToServer("Delta:"+QString::number((int)Time_packet/2));
        }
        if (str.left(6) =="synchr")
       {
           Timer_client.restart();
           cur_time=Timer_client.elapsed();
           TestToServer(this->count_n,this->blocksize);
        }
        if (str.left(12) =="startmaxtime")
       {
            int time_elpr=Timer_client.elapsed();
           //
            quint64 size=this->count_n*(this->blocksize*2+sizeof(quint16));
            double speed=size*1000/time_elpr;
            QString str1;
                    str1.sprintf("%0.3f",speed);

           cur_time=Timer_client.elapsed();

           ui->m_ptxtInfo->append("Test result: client time"+QString::number(time_elpr) +" speed "+str1 + "first packet "+ QString::number(Time_packet)+
                                  "max_time:"+ QString::number(max_time)+
                                  "mid time:" +QString::number(time_elpr/count_n)
                                  );
           emit signal_Set_value_speed(str1);
           StartTestMaxtime(this->blocksize);
           max_time=0;
           Timer_client.restart();
           cur_time=Timer_client.elapsed();
           counter=1;
        }
        if (str.left(1) =="m")
       {

      //            Time_packet=Timer_client.elapsed()/2;  //разница между таймерами на сервере и клиенте
           //
        int time_elpr=Timer_client.elapsed();
        if ((time_elpr-cur_time)>max_time)
        {
          max_time= (time_elpr-cur_time);
      //qDebug()<<  str.left(5);
        }
        if (counter<this->count_n)
        {
        SendTestMaxtime(counter,  str);
        cur_time=time_elpr;
        counter+=1;
         }    else
            {
             emit signalSendStrToServer("Stop:");
            }
        }


        if (str.left(1) =="t")
       {


        int time_elpr=Timer_client.elapsed();
        if (abs(cur_time-time_elpr)>max_time)
        {
          max_time= (time_elpr-cur_time);
      //qDebug()<<  str.left(5);
        }
        cur_time=time_elpr;

        }

        if (str.left(4) =="Stop")
       {

            int time_elpr=Timer_client.elapsed();
           //
            quint64 size=this->count_n*(this->blocksize*2+sizeof(quint16));
            double speed=size*1000/time_elpr;
            QString str1;
                    str1.sprintf("%0.3f",speed);
            ui->m_ptxtInput->setText(str1);
            ui->m_ptxtInfo->append("Test result: client time"+QString::number(time_elpr) +" speed "+str1 + "first packet "+ QString::number(Time_packet)+
                                   "max_time:"+ QString::number(max_time)+
                                   "mid time:" +QString::number(time_elpr/count_n)
                                   );
       emit signal_Set_value_maxmid(QString::number(max_time),QString::number(time_elpr/count_n));
        this->hide();

        }
     //   ui->m_ptxtInfo->append(time.toString() + " " + str);
        m_nNextBlockSize = 0;
    }
}
// ----------------------------------------------------------------------
void MyClient::slotError(QAbstractSocket::SocketError err)
{
    QString strError =
        "Error: " + (err == QAbstractSocket::HostNotFoundError ?
                     "The host was not found." :
                     err == QAbstractSocket::RemoteHostClosedError ?
                     "The remote host is closed." :
                     err == QAbstractSocket::ConnectionRefusedError ?
                     "The connection was refused." :
                     QString(m_pTcpSocket->errorString())
                    );
    ui->m_ptxtInfo->append(strError);
Error_connect=true;
}

// ----------------------------------------------------------------------
void MyClient::slotSendToServer()
{
    QByteArray  arrBlock;
    QDataStream out(&arrBlock, QIODevice::WriteOnly);
    out.setVersion(QDataStream::Qt_4_4);
    out << quint16(0) << QTime::currentTime() << ui->m_ptxtInput->text();

    out.device()->seek(0);
    out << quint16(arrBlock.size() - sizeof(quint16));

    m_pTcpSocket->write(arrBlock);
    ui->m_ptxtInput->setText("");
}


void MyClient::slotSendTestToServer(QString str1)
{

           QByteArray  arrBlock;
           QDataStream out(&arrBlock, QIODevice::WriteOnly);
           out.setVersion(QDataStream::Qt_4_4);
           out << quint16(0) << QTime::currentTime() << str1;

           out.device()->seek(0);
           out << quint16(arrBlock.size() - sizeof(quint16));

           m_pTcpSocket->write(arrBlock);

}

void MyClient::StartNetTest()
{

if (Error_connect)
  {QMessageBox msgBox;
    msgBox.setText(ui->m_ptxtInfo->toPlainText());
    msgBox.exec();
        } else
{
    QString str1;
    str1="";
    int number=9;
str1.append("Start:");
    for(int i=5;i<=blocksize-1;i++)
       {
     //      ba[i]='0';
        int randomValue = qrand() % number;
        //char ch =  char(randomValue);
        str1.append(QString::number(randomValue));
       }

    Timer_client.start();
    emit signalSendStrToServer(str1);//"Start:");
}
}


void MyClient::TestToServer(quint64 count_n, int blocksize)
{
   //quint64 count_n =100;
  // int blocksize =100;
    QString str1;
    str1="";
    int number=9;
str1.append("t");
    for(int i=1;i<=blocksize-1;i++)
       {
     //      ba[i]='0';
        int randomValue = qrand() % number;
     //   char ch =  char(randomValue);
        str1.append(QString::number(randomValue));
       }


//Timer_client.start();
    //   QTime m_time;
//connect(this, SIGNAL(signalSendStrToServer(QString)), SLOT(slotSendTestToServer(QString)));
 //      emit signalSendStrToServer("Start:");
//m_time.start();

       for(quint64 i=1;i<=count_n;i++)
           {

                str1.replace(1,QString::number(i).length()+1,QString::number(i)+":");
                str1.replace(QString::number(i).length()+2,QString::number(Timer_client.elapsed()).length()+2,"z"+QString::number(Timer_client.elapsed())+":");
 // str1.replace(QString::number(i).length()+3,QString::number(m_time.elapsed()).length()+1,QString::number(m_time.elapsed())+":");

  ui->progressBar_net->setValue((quint64) ((i)*100)/ count_n);
emit signalSendStrToServer(str1);
           };
       emit signalSendStrToServer("startmaxtime");


   // ui->m_ptxtInput->setText("");
}
//-----------------------
void MyClient::StartTestMaxtime( int blocksize)
{
   //quint64 count_n =100;
  // int blocksize =100;
    QString str1;
    str1="";
    int number=9;
    str1.append("m1:");
//str1.append(QString::number(j)+":");

    for(int i=3;i<=blocksize-1;i++)
       {

        int randomValue = qrand() % number;
        str1.append(QString::number(randomValue));
       }

emit signalSendStrToServer(str1);

}
void MyClient::SendTestMaxtime(int j, QString str1)
{
   ui->progressBar_net->setValue((quint64) ((j)*100)/ (this->count_n-1));
      str1.replace(1,QString::number(j).length()+1,QString::number(j)+":");
      emit signalSendStrToServer(str1);

}
// ------------------------------------------------------------------
void MyClient::slotConnected()
{
    ui->m_ptxtInfo->append("Received the connected() signal");
}
