#include "include/dialog.h"
#include "ui_dialog.h"
#include "include/mainwindow.h"


Dialog::Dialog(QWidget *parent) :
    QDialog(parent), m_settings("RTI","RTIbanchmark"),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
//readSettings ();  // Если нужно чтобы данные для заполнения брались из Settings
Readinit(); //ели данные нужны из XML
    QObject::connect(ui->pushButton,SIGNAL(clicked()),this,SLOT(RunApp()));
}

Dialog::~Dialog()
{
   writeSettings();


    delete ui;
      ;
}

void Dialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Dialog::RunApp()
{
   // ui->textEdit->setText(osVersion());
    if (ChekReg())
    {

    //ui->dateTimeEdit->setDate(QDate::currentDate());
    Dialog::accept();
    writeSettings();
  // QMessageBox msgBox;
  // msgBox.setText(trUtf8(" Версия ОС :"));
  // msgBox.exec();



    }


}
void Dialog::readSettings()
{ // восстановление полей регистрационной формы из m_settings
    m_settings.beginGroup("/Settings");

     ui->lineEdit_vtname->setText(m_settings.value("/vtname", "").toString());
     ui->lineEdit_vtnumber->setText(m_settings.value("/vtnumber", "").toString());
     ui->lineEdit_manufacturer->setText(m_settings.value("/manufacturer", "").toString());
     ui->lineEdit_osname->setText(m_settings.value("/osname", "").toString());
     ui->lineEdit_osversion->setText(m_settings.value("/osversion", "").toString());

    ui->lineEdit_fio->setText(m_settings.value("/fio", "").toString());
    ui->lineEdit_post->setText(m_settings.value("/post", "").toString());
    ui->lineEdit_organization->setText(m_settings.value("/organization", "").toString());



 /*   int     nWidth     = m_settings.value("/width", width()).toInt();
    int     nHeight    = m_settings.value("/height", height()).toInt();
    int     nComboItem = m_settings.value("/highlight", 0).toInt();
    bool    bEdit      = m_settings.value("/edit", true).toBool();

    m_nCounter = m_settings.value("/counter", 1).toInt();

    QString str = QString().setNum(m_nCounter++);
    m_plbl->setText("This program has been started " + str + " times");

    m_ptxt->setPlainText(strText);

    resize(nWidth, nHeight);

    m_pchk->setChecked(bEdit);
    slotCheckBoxClicked();

    m_pcbo->setCurrentIndex(nComboItem);
    slotComboBoxActivated(nComboItem);
*/
    m_settings.endGroup();
}



void Dialog::writeSettings()
{ // сохранение полей регистрационной формы
     m_settings.beginGroup("/Settings");
     m_settings.setValue("/vtname", ui->lineEdit_vtname->text());
     m_settings.setValue("/vtnumber", ui->lineEdit_vtnumber->text());
     m_settings.setValue("/manufacturer", ui->lineEdit_manufacturer->text());
     m_settings.setValue("/osname", ui->lineEdit_osname->text());
     m_settings.setValue("/osversion", ui->lineEdit_osversion->text());

     m_settings.setValue("/fio", ui->lineEdit_fio->text());
     m_settings.setValue("/post", ui->lineEdit_post->text());
     m_settings.setValue("/organization", ui->lineEdit_organization->text());

   m_settings.endGroup();
}

bool Dialog::ChekReg()
{  //проверка заполнения регистрационной формы
QMessageBox msgBox;
   if  (Dialog::ui->lineEdit_vtname->text().length()==0)
    {

       msgBox.setText(trUtf8("  Не заполнено Наименование ВТ. \n Все поля обязательны для заполнения!!! "));
       msgBox.exec();
       return false;
   } else
   if  (Dialog::ui->lineEdit_vtnumber->text().length()==0)
    {

       msgBox.setText(trUtf8("  Не заполнен номер ВТ. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
       return false;
   } else
   if  (Dialog::ui->lineEdit_manufacturer->text().length()==0)
     {
         msgBox.setText(trUtf8("  Не заполнено поле Производитель ВТ. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
         return false;
     } else
   if  (Dialog::ui->lineEdit_osname->text().length()==0)
     {
         msgBox.setText(trUtf8("  Не заполнено поле наименование ОС. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
         return false;
     } else
  if  (Dialog::ui->lineEdit_osversion->text().length()==0)
     {
         msgBox.setText(trUtf8("  Не заполнено поле Версия ОС. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
         return false;
     } else
  if  (Dialog::ui->lineEdit_fio->text().length()==0)
     {
         msgBox.setText(trUtf8("  Не заполнено поле ФИО. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
         return false;
      } else
  if  (Dialog::ui->lineEdit_post->text().length()==0)
      {
         msgBox.setText(trUtf8("  Не заполнено поле Должность. \n Все поля обязательны для заполнения!!! "));
         msgBox.exec();
         return false;
      } else
   if  (Dialog::ui->lineEdit_organization->text().length()==0)
      {
        msgBox.setText(trUtf8("  Не заполнено поле Организация. \n Все поля обязательны для заполнения!!! "));
        msgBox.exec();
        return false;
      } else

    return true;

//replace(" ","").(
       }

// чтение из xml
void Dialog::traverseNode_init(const QDomNode& node)
{
   QDomNode domNode = node.firstChild();

   while(!domNode.isNull()) {
       if(domNode.isElement()) {

          QDomElement domElement = domNode.toElement();
        //  qDebug() << "t: "; //<< domNode.toText();

          if(!domElement.isNull()) {
             // if(domElement.tagName() == "test") {
               //  qDebug() << "Attr: "
               //          << domElement.attribute("id", "");
               //   domElement.childNodes()

              //}
              //else {
              //    qDebug() << "TagName: " << domElement.tagName()
               //            << "\tText: " << domElement.text();

               //  qDebug() << "TagName: " << domElement.tagName()
                // << "\tText: " << domElement.text();
/*

              switch(domElement.tagName())
              {
              case "vtname":
                   ui->lineEdit_vtname->setText(domElement.text());
                  break ;
              case "vtnumber" :
                    ui->lineEdit_vtnumber->setText(domElement.text());
                  break ;
              case "manufacturer" :
                   ui->lineEdit_manufacturer->setText(domElement.text());
                  break ;
              case "osname":
                   ui->lineEdit_osname->setText(domElement.text());
                  break ;
              case "osversion":
                   ui->lineEdit_osversion->setText(domElement.text());
                  break ;
              case "fio":
                   ui->lineEdit_fio->setText(domElement.text());
                  break ;
              case "post":
                  ui->lineEdit_post->setText(domElement.text());
                  break ;
              case "organization":
                   ui->lineEdit_organization->setText(domElement.text());
                   break ;
              }

             */

                  if(domElement.tagName() == "vtname"){
                   ui->lineEdit_vtname->setText(domElement.text());
                  }
                  if(domElement.tagName() == "vtnumber"){
                   ui->lineEdit_vtnumber->setText(domElement.text());
                  }
                  if(domElement.tagName() == "manufacturer"){
                   ui->lineEdit_manufacturer->setText(domElement.text());
                  }
                  if(domElement.tagName() == "osname"){

                  ui->lineEdit_osname->setText(domElement.text());
                  }

                  if(domElement.tagName() == "osversion"){
                   ui->lineEdit_osversion->setText(domElement.text());
                  }
                  if(domElement.tagName() == "fio"){
                   ui->lineEdit_fio->setText(domElement.text());
                  }
                  if(domElement.tagName() == "post"){
                   ui->lineEdit_post->setText(domElement.text());
                  }
                  if(domElement.tagName() == "organization"){

                  ui->lineEdit_organization->setText(domElement.text());
                  }





             }
         // }
       }
       traverseNode_init(domNode);
       domNode = domNode.nextSibling();

}
}
void Dialog::Readinit()
{
    QDomDocument domDoc1;
    QFile        file("initbamchmark.xml");

    if(file.open(QIODevice::ReadOnly)) {
        if(domDoc1.setContent(&file)) {
            QDomElement domElement= domDoc1.documentElement();
            traverseNode_init(domElement);
        }
        file.close();
    }
}
