#include <QtCore/qprocess.h>

#include "include/enviropments.h"
#include "stdlib.h"
#include <iostream>
#include <cstdio>
enviropments::enviropments() {
}

enviropments::~enviropments() {
}
const char* enviropments::getPlatform()
{
    QProcess* proc = new QProcess();
    QStringList args;
    args << "-rsm";
    proc->start("uname",args);
    proc->waitForFinished();
    QByteArray out = proc->readAllStandardOutput();//>readLine();
    proc->close();
    //QString res;
    //res = res.fromAscii(out.data(),out.size());
    return out.data();
}

const char* enviropments::getCPU_name()
{
//возвращает наименование процессора /proc/cpuinfo
//Proc_name.sh скрипт для запуска команд с | -Pipe
//#!/bin/sh
//cat /proc/cpuinfo | grep 'model name' | sed -e 's/.*: //'
//
#ifdef Q_OS_LINUX
  {


        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./Proc_name.sh";
        proc->start(sCmd, slArgs);
       // myProcess.waitForFinished();
       // qDebug() << myProcess.readAllStandardOutput();



       // QStringList options;
       // options << "-c" << "cat /proc/cpuinfo | grep 'model name' | sed -e 's/.*: //'";
       // QProcess process;
        //process.start("/bin/sh", options);


    // proc->start("/bin/sh - c \"cat /proc/cpuinfo | grep \"model name\" | sed -e 's/.*: //'\"");
    // proc->start("/bin/sh - c \"cat /proc/cpuinfo\"");
     // proc->start("grep 'model name' < /proc/cpuinfo | cut -d ':' -f 2");
      //proc->start("cat /proc/cpuinfo | grep \"model name\" | sed -e 's/.*: //'");

      //proc->start("cat /proc/cpuinfo |egrep MHz");
      proc->waitForFinished();
       QByteArray out =proc->readLine();

      proc->close();
     // proc->deleteLater();

      return out.replace("\a","").trimmed().data();

   /*  process = new QProcess ;
     process->setReadChannelMode(QProcess::MergedChannels);
     connect (process, SIGNAL(readyReadStandardOutput()), this, SLOT(showExternalOutput()));
     //
     QDir WorkDir(QDir::homePath ());
     WorkDir.cd(QString(".niieor"));
     WorkDir.cd(QString("constructor"));
     //process->setWorkingDirectory(APPpath+"/player/linux");
     QDir::setCurrent(WorkDir.absolutePath());
     process->start("MAXplayer.exe");*/
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {*
   /*  process = new QProcess ;
     process->setReadChannelMode(QProcess::MergedChannels);
     connect (process, SIGNAL(readyReadStandardOutput()), this, SLOT(showExternalOutput()));
     //process->setWorkingDirectory(APPpath+"/player/win32");
     QDir::setCurrent(QDir::homePath ()+ QDir::separator()+ QString(".niieor") + QDir::separator() + QString("constructor"));
     process->start("maxplayer.exe");*/
  }
  #endif

/*void myMainWindow::showExternalOutput() \
{
    QByteArray bytes = process->readAllStandardOutput();
    QString temp = bytes;
}
   */

}


const char*  enviropments::getCPU_MHz()
{
//возвращает частоту процессора /proc/cpuinfo
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
      //  QString str;
        QProcess* proc1 = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./Proc_MHz.sh";
        proc1->start(sCmd, slArgs);
        proc1->waitForFinished();
       QByteArray out =proc1->readAll();
        proc1->close();
      //  proc1->deleteLater();
      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}
const char* enviropments::getCPU_NProc()
{
//возвращает количество процессоров процессора /proc/cpuinfo
// вариант использовать lscpu
#ifdef Q_OS_LINUX
  {


using namespace std;


{
 /*   int numCPU = sysconf(_SC_NPROCESSORS_ONLN);
    //cout << numCPU << endl;
    QByteArray out;

     sprintf(out.data(), "%d", numCPU);
    return out.data();
*/

        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./Proc_Cores.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.data();


  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {

  }
  #endif


}
}

const char* enviropments::getVGA_Name()
{
//возвращает частоту процессора /proc/cpuinfo
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./VGA_Name.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}

const char* enviropments::getVGA_V()
{
//возвращает объем видеопамяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./VGA_V.sh";
      //  slArgs << "./VGA_Name.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray err=proc->readAllStandardError();
        QByteArray out =proc->readAll();
        proc->close();
        if (err.length()>=1) {
        return "";
        } else
      return out.data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}

const char* enviropments::getVGA_isOpenGL()
{
//проверяет поддержу OpenGL

#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );


        QStringList slArgs;
        slArgs <<"./VGA_isOpenGL.sh";

        proc->start(sCmd, slArgs);
       // proc->start("glxinfo");

        proc->waitForFinished();
       QByteArray out =proc->readAll();
       //QByteArray out =proc->readAllStandardError();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}

const char* enviropments::getRAM_Total()
{
//возвращает объем оперативной памяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./RAM_Total.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}

const char* enviropments::getRAM_Free()
{
//возвращает объем оперативной памяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./RAM_Free.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}

const char* enviropments::getHDD_Total()
{
//возвращает объем оперативной памяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./HDD_getSize.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}
const char* enviropments::getHDD_Free()
{
//возвращает объем оперативной памяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./HDD_getAvailibleSize.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}


const char* enviropments::get_ports_count()
{
//возвращает объем оперативной памяти
//Proc_name.sh скрипт для запуска команд с | -Pipe
#ifdef Q_OS_LINUX
  {
        QProcess* proc = new QProcess();
        QString sCmd( "/bin/sh" );
        QStringList slArgs;
        slArgs << "./PortsCount.sh";
        proc->start(sCmd, slArgs);
        proc->waitForFinished();
        QByteArray out =proc->readAll();
        proc->close();

      return out.replace("\a","").trimmed().data();
  }
  #endif

  //Windows
  #ifdef Q_OS_WIN32
  {
  }
  #endif
}
