#include "include/form.h"
#include "ui_form.h"
#include "include/mainwindow.h"
#include <QMenuBar>
#include <QStatusBar>
#include <QDesktopWidget>


Form::Form(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Form)
{
    ui->setupUi(this);

       QMenu *fileMenu;
       QAction *newAct;
       QAction *openAct;
        QAction *exitAct;
       QMenuBar *menuBar = new QMenuBar(this);

       newAct = new QAction(tr("&New"), this);
       newAct->setShortcut(tr("Ctrl+N"));
       newAct->setStatusTip(tr("Create a new file"));
       openAct = new QAction(tr("&Open..."), this);
       openAct->setShortcut(tr("Ctrl+O"));
       openAct->setStatusTip(tr("Open an existing file"));
       exitAct = new QAction(tr("&Exit..."), this);
       exitAct->setShortcut(tr("Ctrl+X"));
       exitAct->setStatusTip(tr("Exit program"));

       fileMenu = menuBar->addMenu(tr("File"));
       fileMenu->addAction(newAct);
       fileMenu->addAction(openAct);
       fileMenu->addSeparator();
       fileMenu->addAction(exitAct);

       menuBar->addMenu(tr("About"));
       ui->menuLayout->setMenuBar(menuBar);


        QStatusBar *statusbar = new QStatusBar();

        QLabel *stLabel = new QLabel(QDateTime::currentDateTime().toString());
        statusbar->addWidget(stLabel);
      ui->Layout_Statusbar->addWidget(statusbar);


      /*  QWidget *window = new QWidget();
             window->resize(640, 480);
             window->show();
             //QPushButton *button = new QPushButton(tr("Press me"), window);
           //   button->move(100, 100);
           //   button->show();
        QHBoxLayout *menuLayout = new QHBoxLayout();

        QMenu *fileMenu;
           QAction *newAct;
           QAction *openAct;
            QAction *exitAct;
           QMenuBar *menuBar = new QMenuBar(this);

           newAct = new QAction(tr("&New"), this);
           newAct->setShortcut(tr("Ctrl+N"));
           newAct->setStatusTip(tr("Create a new file"));
           openAct = new QAction(tr("&Open..."), this);
           openAct->setShortcut(tr("Ctrl+O"));
           openAct->setStatusTip(tr("Open an existing file"));
           exitAct = new QAction(tr("&Exit..."), this);
           exitAct->setShortcut(tr("Ctrl+X"));
           exitAct->setStatusTip(tr("Exit program"));

           fileMenu = menuBar->addMenu(tr("File"));
           fileMenu->addAction(newAct);
           fileMenu->addAction(openAct);
           fileMenu->addSeparator();
           fileMenu->addAction(exitAct);

           menuBar->addMenu(tr("About"));
           menuLayout->addWidget(menuBar);
         menuLayout->setSpacing(0);

             QStatusBar *statusbar = new QStatusBar(window);
             //    QDateTimeEdit dt = new QDateTimeEdit();

     QLabel *stLabel = new QLabel(tr("StatusBar"));
               //  dt.dateTime()=QDateTime::currentDateTime();


                    statusbar->addWidget(stLabel);



                   QLabel *queryLabel = new QLabel(tr("Query:"));
                   QLineEdit *queryEdit = new QLineEdit();
                   QTableView *resultView = new QTableView();
                   QPushButton *button = new QPushButton(tr("Press me"));
                   QCheckBox *chekbox = new QCheckBox("CheckBox");
               //    QListBox *listbox = new QListBox();
             //      QComboBox *combobox= new QComboBox();
              - панель вкладок (tab control);
                   - вкладка (tab);
                   - таблица (table);
                   - меню (menu);
                   - панель инструментов (tool bar);*/
    /*
                   QHBoxLayout *queryLayout = new QHBoxLayout();
                   queryLayout->addWidget(queryLabel);
                   queryLayout->addWidget(queryEdit);
                   queryLayout->addWidget(chekbox);
                   queryLayout->addWidget(button);




                   QVBoxLayout *mainLayout = new QVBoxLayout();
                   mainLayout->addLayout(menuLayout);
                   mainLayout->addLayout(queryLayout);
                   mainLayout->addWidget(resultView);
                   mainLayout->addWidget(statusbar);
                   window->setLayout(mainLayout);

    */
}

Form::~Form()
{
    delete ui;
}

void Form::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Form::SetFrameCount(int m_frameCount)
{
QString str;
    ui->label_out->setText(str.sprintf("Frames: %d",m_frameCount));

}

//возвращает количество времени на перерисовку окна m_frameCount раз
int Form::CalculateFPS(int m_frameCount)
{
QTime m_time;
m_time.start();
 QString str;

 QDesktopWidget *d = QApplication::desktop();
 int cur_x = d->width();     // returns desktop width
 int cur_y = d->height();    // returns desktop height
int pixelx_move= cur_x-this->width(); //количество пикселей по ширине в экране
int pixely_move=cur_y-this->height() - this->geometry().y();//количество пикселей по высоте в экране без заголовка
this->move(0,0);
for(int i=1;i<=m_frameCount;i++)
    {
//if i<isize*ksize
      //this->SetFrameCount(i);
//    QPoint pos= this->pos();
  // this->pos().x()= i%pixels_move;
     this->move(i%pixelx_move,i%pixely_move);

  //   this->move(p[i%4]);  //
      ui->label_out->setText(str.sprintf("Frames: %d",i));
      this->repaint();

    }
//int elpresedtime =m_time->elapsed();
//delete m_time;
return m_time.elapsed();
}
